# Export combined metadata file.
require 'utility'

# Spconfig.save_metadata_to_file()
metadata_type_to_was_written = Spconfig.save_metadatas_to_file()

# Make sure the permissions are correct
basepath = Rails.configuration.sp_metadatafile_basedir

cmd = "chown -R root.www-data #{basepath}"
`#{cmd}`

cmd = "chmod -R g+rw #{basepath}"
`#{cmd}`

# If the 'combined' file was written, send it to Amazon S3.
if (Rails.configuration.combined_metadata_to_s3_send) then
  if (metadata_type_to_was_written['combined']) then
    Utility.logger.info("[export_metadata] sending combined metadata to S3")

    bucket_name = Rails.configuration.combined_metadata_to_s3_bucket
    credentials = Rails.configuration.combined_metadata_to_s3_credentials
    directory   = Rails.env

    cmds = ['/usr/share/spdb/bin/send-metadata-to-s3',
            bucket_name,
            directory,
            "--credentials-file=#{credentials}",
           ]

    cmd = cmds.join(' ')

    stdout, stderr, p_status = Open3.capture3(cmd)
    rc = p_status.exitstatus()
    Utility.logger.debug("[#{stdout}][#{stderr}][#{p_status}][#{rc}]")

    if (rc == 0) then
      Utility.logger.debug("S3 upload command suceeded")
    else
      # An error.
      Utility.logger.error("S3 command '#{cmd}' failed: #{stderr}")
      exit(1)
    end
  else
    Utility.logger.info("[export_metadata] not time to send combined metadata to S3")
  end
else
  Utility.logger.info("[export_metadata] not sending metadata to S3 (send disabled)")
end
